package edu.columbia.yourUNI;

import edu.columbia.cs.coms4701.search.adversarial.GamePlayingAgentProgram;
import edu.columbia.cs.coms4701.search.adversarial.GameProblem;
import edu.columbia.cs.coms4701.search.adversarial.MinimaxFunctionWithHeuristic;
import edu.columbia.cs.coms4701.agent.environments.pente.PenteAction;
import edu.columbia.cs.coms4701.agent.environments.pente.PentePercept;
import edu.columbia.cs.coms4701.agent.environments.pente.PentePerceptGame;

import java.util.Set;
import java.util.Map;

/**
 * PenteAgentProgram using something clever....
 *
 * @author
 * @version 0.1
 *          <p/>
 *
 */

public class PenteAgentProgram
	implements GamePlayingAgentProgram<PenteAction, PentePercept, MyPenteState>
{
	// --------------- Class fields ---------------
	public static final String author = "yourUNI";
	public static final String description = "Something clever...";
	// --------------- Class Methods ---------------
	// --------------- Constructors ---------------
	// --------------- Methods ---------------


	/**
	 * Given a set of percepts, chooses the next action.
	 *
	 * <p>My agent program...</p>
	 *
	 * @param pentePercepts
	 * @return an action
	 */
	public PenteAction nextAction(Set<PentePercept> pentePercepts) {

		// interpret initial game percepts
		for (PentePercept thisPercept : pentePercepts) {
			if (thisPercept instanceof PentePerceptGame) {
				; // do some stuff
			}
		}

		// Pose the problem if I haven't yet
		if (myProblem == null) {
			myProblem = poseGameProblem();
			currentState = myProblem.getInitialState();
			myEvaluation = new MyEvaluationFunction();
		}

		// Figure out what state I'm in
		currentState = updateStateFromPercepts(currentState, pentePercepts);

		// Enumerate possible actions from this state
		Map<PenteAction, MyPenteState> possibleActions = myProblem.successorsFromState(currentState);

		// For each of the resulting possible states, evaluate with a StateEvaluationFunction
		// this part is up to you...

		// Choose an appropriate action
		PenteAction bestAction = new PenteAction(9,9);

		return bestAction;
	}

	/**
	 * Returns a Game Problem instance, describing the nature of the game.
	 * @return a game problem
	 */
	public GameProblem<PenteAction, MyPenteState> poseGameProblem() {
		return new MyPenteProblem(); // <--- this will need a fancier constructor to tell the problem about the game rules
	}

	/**
	 * Returns the current state, given a previous state and a set of percepts
	 *
	 * <p>My implementation works by....</p>
	 *
	 * @param myPenteState
	 * @param pentePercepts
	 * @return new current state
	 */
	public MyPenteState updateStateFromPercepts(MyPenteState myPenteState, Set<PentePercept> pentePercepts) {
		return new MyPenteState();
	}


	// --------------- Accessors ---------------

	/**
	 * Returns the author's UNI, e.g. "awh2101
	 * @return a UNI
	 */
	public String getAuthor() {
		return author;
	}

	/**
	 * Returns a short description of this agent program
	 * @return single-sentence description
	 */
	public String getDescription() {
		return description;
	}
	// --------------- Instance variables ---------------
	GameProblem<PenteAction, MyPenteState> myProblem;
	MinimaxFunctionWithHeuristic<PenteAction, MyPenteState, MyPenteProblem> myEvaluation;
	MyPenteState currentState;
}
